TypeScript SDK
import { Client } from "@notionhq/client"
const notion = new Client({ auth: process.env.NOTION_API_KEY })
const response = await notion.dataSources.create({
parent: {
database_id: "a1b2c3d4-e5f6-7890-abcd-ef1234567890"
},
title: [{ text: { content: "My Data Source" } }],
properties: {
Name: { title: {} },
Status: {
select: {
options: [
{ name: "To Do", color: "red" },
{ name: "Done", color: "green" }
]
}
}
}
})curl --request POST \
--url https://api.notion.com/v1/data_sources \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Notion-Version: <notion-version>' \
--data '
{
"parent": {
"database_id": "<string>",
"type": "database_id"
},
"properties": {},
"title": [
{
"text": {
"content": "<string>",
"link": {
"url": "https://www.notion.com"
}
},
"annotations": {
"bold": true,
"italic": true,
"strikethrough": true,
"underline": true,
"code": true
},
"type": "text"
}
],
"icon": {
"file_upload": {
"id": "<string>"
},
"type": "file_upload"
}
}
'import requests
url = "https://api.notion.com/v1/data_sources"
payload = {
"parent": {
"database_id": "<string>",
"type": "database_id"
},
"properties": {},
"title": [
{
"text": {
"content": "<string>",
"link": { "url": "https://www.notion.com" }
},
"annotations": {
"bold": True,
"italic": True,
"strikethrough": True,
"underline": True,
"code": True
},
"type": "text"
}
],
"icon": {
"file_upload": { "id": "<string>" },
"type": "file_upload"
}
}
headers = {
"Notion-Version": "<notion-version>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.notion.com/v1/data_sources",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'parent' => [
'database_id' => '<string>',
'type' => 'database_id'
],
'properties' => [
],
'title' => [
[
'text' => [
'content' => '<string>',
'link' => [
'url' => 'https://www.notion.com'
]
],
'annotations' => [
'bold' => true,
'italic' => true,
'strikethrough' => true,
'underline' => true,
'code' => true
],
'type' => 'text'
]
],
'icon' => [
'file_upload' => [
'id' => '<string>'
],
'type' => 'file_upload'
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Notion-Version: <notion-version>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.notion.com/v1/data_sources"
payload := strings.NewReader("{\n \"parent\": {\n \"database_id\": \"<string>\",\n \"type\": \"database_id\"\n },\n \"properties\": {},\n \"title\": [\n {\n \"text\": {\n \"content\": \"<string>\",\n \"link\": {\n \"url\": \"https://www.notion.com\"\n }\n },\n \"annotations\": {\n \"bold\": true,\n \"italic\": true,\n \"strikethrough\": true,\n \"underline\": true,\n \"code\": true\n },\n \"type\": \"text\"\n }\n ],\n \"icon\": {\n \"file_upload\": {\n \"id\": \"<string>\"\n },\n \"type\": \"file_upload\"\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Notion-Version", "<notion-version>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.notion.com/v1/data_sources")
.header("Notion-Version", "<notion-version>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"parent\": {\n \"database_id\": \"<string>\",\n \"type\": \"database_id\"\n },\n \"properties\": {},\n \"title\": [\n {\n \"text\": {\n \"content\": \"<string>\",\n \"link\": {\n \"url\": \"https://www.notion.com\"\n }\n },\n \"annotations\": {\n \"bold\": true,\n \"italic\": true,\n \"strikethrough\": true,\n \"underline\": true,\n \"code\": true\n },\n \"type\": \"text\"\n }\n ],\n \"icon\": {\n \"file_upload\": {\n \"id\": \"<string>\"\n },\n \"type\": \"file_upload\"\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.notion.com/v1/data_sources")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Notion-Version"] = '<notion-version>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"parent\": {\n \"database_id\": \"<string>\",\n \"type\": \"database_id\"\n },\n \"properties\": {},\n \"title\": [\n {\n \"text\": {\n \"content\": \"<string>\",\n \"link\": {\n \"url\": \"https://www.notion.com\"\n }\n },\n \"annotations\": {\n \"bold\": true,\n \"italic\": true,\n \"strikethrough\": true,\n \"underline\": true,\n \"code\": true\n },\n \"type\": \"text\"\n }\n ],\n \"icon\": {\n \"file_upload\": {\n \"id\": \"<string>\"\n },\n \"type\": \"file_upload\"\n }\n}"
response = http.request(request)
puts response.read_body{
"object": "data_source",
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"properties": {}
}{
"object": "error",
"message": "<string>",
"code": "invalid_json",
"status": 400,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "unauthorized",
"status": 401,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "restricted_resource",
"status": 403,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "object_not_found",
"status": 404,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "row_limit_exceeded",
"status": 406,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "conflict_error",
"status": 409,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "rate_limited",
"status": 429,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "internal_server_error",
"status": 500,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "service_unavailable",
"status": 503,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "gateway_timeout",
"status": 504,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "service_overload",
"status": 529,
"additional_data": {}
}Data sources
Create a data source
POST
/
v1
/
data_sources
TypeScript SDK
import { Client } from "@notionhq/client"
const notion = new Client({ auth: process.env.NOTION_API_KEY })
const response = await notion.dataSources.create({
parent: {
database_id: "a1b2c3d4-e5f6-7890-abcd-ef1234567890"
},
title: [{ text: { content: "My Data Source" } }],
properties: {
Name: { title: {} },
Status: {
select: {
options: [
{ name: "To Do", color: "red" },
{ name: "Done", color: "green" }
]
}
}
}
})curl --request POST \
--url https://api.notion.com/v1/data_sources \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Notion-Version: <notion-version>' \
--data '
{
"parent": {
"database_id": "<string>",
"type": "database_id"
},
"properties": {},
"title": [
{
"text": {
"content": "<string>",
"link": {
"url": "https://www.notion.com"
}
},
"annotations": {
"bold": true,
"italic": true,
"strikethrough": true,
"underline": true,
"code": true
},
"type": "text"
}
],
"icon": {
"file_upload": {
"id": "<string>"
},
"type": "file_upload"
}
}
'import requests
url = "https://api.notion.com/v1/data_sources"
payload = {
"parent": {
"database_id": "<string>",
"type": "database_id"
},
"properties": {},
"title": [
{
"text": {
"content": "<string>",
"link": { "url": "https://www.notion.com" }
},
"annotations": {
"bold": True,
"italic": True,
"strikethrough": True,
"underline": True,
"code": True
},
"type": "text"
}
],
"icon": {
"file_upload": { "id": "<string>" },
"type": "file_upload"
}
}
headers = {
"Notion-Version": "<notion-version>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.notion.com/v1/data_sources",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'parent' => [
'database_id' => '<string>',
'type' => 'database_id'
],
'properties' => [
],
'title' => [
[
'text' => [
'content' => '<string>',
'link' => [
'url' => 'https://www.notion.com'
]
],
'annotations' => [
'bold' => true,
'italic' => true,
'strikethrough' => true,
'underline' => true,
'code' => true
],
'type' => 'text'
]
],
'icon' => [
'file_upload' => [
'id' => '<string>'
],
'type' => 'file_upload'
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Notion-Version: <notion-version>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.notion.com/v1/data_sources"
payload := strings.NewReader("{\n \"parent\": {\n \"database_id\": \"<string>\",\n \"type\": \"database_id\"\n },\n \"properties\": {},\n \"title\": [\n {\n \"text\": {\n \"content\": \"<string>\",\n \"link\": {\n \"url\": \"https://www.notion.com\"\n }\n },\n \"annotations\": {\n \"bold\": true,\n \"italic\": true,\n \"strikethrough\": true,\n \"underline\": true,\n \"code\": true\n },\n \"type\": \"text\"\n }\n ],\n \"icon\": {\n \"file_upload\": {\n \"id\": \"<string>\"\n },\n \"type\": \"file_upload\"\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Notion-Version", "<notion-version>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.notion.com/v1/data_sources")
.header("Notion-Version", "<notion-version>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"parent\": {\n \"database_id\": \"<string>\",\n \"type\": \"database_id\"\n },\n \"properties\": {},\n \"title\": [\n {\n \"text\": {\n \"content\": \"<string>\",\n \"link\": {\n \"url\": \"https://www.notion.com\"\n }\n },\n \"annotations\": {\n \"bold\": true,\n \"italic\": true,\n \"strikethrough\": true,\n \"underline\": true,\n \"code\": true\n },\n \"type\": \"text\"\n }\n ],\n \"icon\": {\n \"file_upload\": {\n \"id\": \"<string>\"\n },\n \"type\": \"file_upload\"\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.notion.com/v1/data_sources")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Notion-Version"] = '<notion-version>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"parent\": {\n \"database_id\": \"<string>\",\n \"type\": \"database_id\"\n },\n \"properties\": {},\n \"title\": [\n {\n \"text\": {\n \"content\": \"<string>\",\n \"link\": {\n \"url\": \"https://www.notion.com\"\n }\n },\n \"annotations\": {\n \"bold\": true,\n \"italic\": true,\n \"strikethrough\": true,\n \"underline\": true,\n \"code\": true\n },\n \"type\": \"text\"\n }\n ],\n \"icon\": {\n \"file_upload\": {\n \"id\": \"<string>\"\n },\n \"type\": \"file_upload\"\n }\n}"
response = http.request(request)
puts response.read_body{
"object": "data_source",
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"properties": {}
}{
"object": "error",
"message": "<string>",
"code": "invalid_json",
"status": 400,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "unauthorized",
"status": 401,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "restricted_resource",
"status": 403,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "object_not_found",
"status": 404,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "row_limit_exceeded",
"status": 406,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "conflict_error",
"status": 409,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "rate_limited",
"status": 429,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "internal_server_error",
"status": 500,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "service_unavailable",
"status": 503,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "gateway_timeout",
"status": 504,
"additional_data": {}
}{
"object": "error",
"message": "<string>",
"code": "service_overload",
"status": 529,
"additional_data": {}
}Use this API to add an additional data source to an existing database. The
properties follow the same structure as the initial schema passed to initial_data_source[properties] in the Create a database API, but can be managed independently of the properties of any sibling data sources.
A standard “table” view is created alongside the new data source. To customize database views, use the Notion app. Managing views is not currently supported in the API.Authorizations
Headers
The API version to use for this request. The latest version is 2026-03-11.
Available options:
2026-03-11 Body
application/json